/*
	SDZGeoCode_ServiceExample.m
	Provides example and test runs the service's proxy methods.
	Generated by SudzC.com
*/
#import "SDZGeoCode_ServiceExample.h"
#import "SDZGeoCode_Service.h"

@implementation SDZGeoCode_ServiceExample

- (void)run {
	// Create the service
	SDZGeoCode_Service* service = [SDZGeoCode_Service service];
	service.logging = YES;
	// service.username = @"username";
	// service.password = @"password";
	
   NSString *address = @"301 South Market Street San Jose CA";

	// Returns SDZArrayOfGeocoderResult*. 
	[service geocode:self action:@selector(geocodeHandler:) location: address];

	// Returns SDZArrayOfGeocoderAddressResult*. 
//	[service geocode_address:self action:@selector(geocode_addressHandler:) address: @""];

	// Returns SDZArrayOfGeocoderIntersectionResult*. 
//	[service geocode_intersection:self action:@selector(geocode_intersectionHandler:) intersection: @""];
}

	

// Handle the response from geocode.
		
- (void) geocodeHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZArrayOfGeocoderResult* result
		SDZArrayOfGeocoderResult* result = (SDZArrayOfGeocoderResult*)value;
	NSLog(@"geocode returned the value: %@", result);
			
   for(SDZGeocoderResult *item in result) {
      NSLog(@"latitude, longitude = %f, %f", [item lat], [item longitude]);
   }
}
	

// Handle the response from geocode_address.
		
- (void) geocode_addressHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZArrayOfGeocoderAddressResult* result
		SDZArrayOfGeocoderAddressResult* result = (SDZArrayOfGeocoderAddressResult*)value;
	NSLog(@"geocode_address returned the value: %@", result);
			
}
	

// Handle the response from geocode_intersection.
		
- (void) geocode_intersectionHandler: (id) value {

	// Handle errors
	if([value isKindOfClass:[NSError class]]) {
		NSLog(@"%@", value);
		return;
	}

	// Handle faults
	if([value isKindOfClass:[SoapFault class]]) {
		NSLog(@"%@", value);
		return;
	}				
			

	// Do something with the SDZArrayOfGeocoderIntersectionResult* result
		SDZArrayOfGeocoderIntersectionResult* result = (SDZArrayOfGeocoderIntersectionResult*)value;
	NSLog(@"geocode_intersection returned the value: %@", result);
			
}
	

@end
		