/*
	SDZGeocoderAddressResult.h
	The implementation of properties and methods for the SDZGeocoderAddressResult object.
	Generated by SudzC.com
*/
#import "SDZGeocoderAddressResult.h"

@implementation SDZGeocoderAddressResult
	@synthesize number = _number;
	@synthesize zip = _zip;
	@synthesize suffix = _suffix;
	@synthesize prefix = _prefix;
	@synthesize type = _type;
	@synthesize street = _street;
	@synthesize state = _state;
	@synthesize city = _city;
	@synthesize lat = _lat;
	@synthesize longitude = _longitude;

	- (id) init
	{
		if(self = [super init])
		{
			self.suffix = nil;
			self.prefix = nil;
			self.type = nil;
			self.street = nil;
			self.state = nil;
			self.city = nil;

		}
		return self;
	}

	+ (SDZGeocoderAddressResult*) newWithNode: (CXMLNode*) node
	{
		if(node == nil) { return nil; }
		return (SDZGeocoderAddressResult*)[[[SDZGeocoderAddressResult alloc] initWithNode: node] autorelease];
	}

	- (id) initWithNode: (CXMLNode*) node {
		if(self = [super initWithNode: node])
		{
			self.number = [[Soap getNodeValue: node withName: @"number"] intValue];
			self.zip = [[Soap getNodeValue: node withName: @"zip"] intValue];
			self.suffix = [Soap getNodeValue: node withName: @"suffix"];
			self.prefix = [Soap getNodeValue: node withName: @"prefix"];
			self.type = [Soap getNodeValue: node withName: @"type"];
			self.street = [Soap getNodeValue: node withName: @"street"];
			self.state = [Soap getNodeValue: node withName: @"state"];
			self.city = [Soap getNodeValue: node withName: @"city"];
			self.lat = [[Soap getNodeValue: node withName: @"lat"] floatValue];
			self.longitude = [[Soap getNodeValue: node withName: @"long"] floatValue];
		}
		return self;
	}

	- (NSMutableString*) serialize
	{
		return [self serialize: @"GeocoderAddressResult"];
	}
  
	- (NSMutableString*) serialize: (NSString*) nodeName
	{
		NSMutableString* s = [[NSMutableString alloc] init];
		[s appendFormat: @"<%@", nodeName];
		[s appendString: [self serializeAttributes]];
		[s appendString: @">"];
		[s appendString: [self serializeElements]];
		[s appendFormat: @"</%@>", nodeName];
		return [s autorelease];
	}
	
	- (NSMutableString*) serializeElements
	{
		NSMutableString* s = [super serializeElements];
		[s appendFormat: @"<number>%@</number>", [NSString stringWithFormat: @"%i", self.number]];
		[s appendFormat: @"<zip>%@</zip>", [NSString stringWithFormat: @"%i", self.zip]];
		if (self.suffix != nil) [s appendFormat: @"<suffix>%@</suffix>", [[self.suffix stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.prefix != nil) [s appendFormat: @"<prefix>%@</prefix>", [[self.prefix stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.type != nil) [s appendFormat: @"<type>%@</type>", [[self.type stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.street != nil) [s appendFormat: @"<street>%@</street>", [[self.street stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.state != nil) [s appendFormat: @"<state>%@</state>", [[self.state stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		if (self.city != nil) [s appendFormat: @"<city>%@</city>", [[self.city stringByReplacingOccurrencesOfString:@"\"" withString:@"&quot;"] stringByReplacingOccurrencesOfString:@"&" withString:@"&amp;"]];
		[s appendFormat: @"<lat>%@</lat>", [NSString stringWithFormat: @"%f", self.lat]];
		[s appendFormat: @"<long>%@</long>", [NSString stringWithFormat: @"%f", self.longitude]];

		return s;
	}
	
	- (NSMutableString*) serializeAttributes
	{
		NSMutableString* s = [super serializeAttributes];

		return s;
	}
	
	-(BOOL)isEqual:(id)object{
		if(object != nil && [object isKindOfClass:[SDZGeocoderAddressResult class]]) {
			return [[self serialize] isEqualToString:[object serialize]];
		}
		return NO;
	}
	
	-(NSUInteger)hash{
		return [Soap generateHash:self];

	}
	
	- (void) dealloc
	{
		if(self.suffix != nil) { [self.suffix release]; }
		if(self.prefix != nil) { [self.prefix release]; }
		if(self.type != nil) { [self.type release]; }
		if(self.street != nil) { [self.street release]; }
		if(self.state != nil) { [self.state release]; }
		if(self.city != nil) { [self.city release]; }
		[super dealloc];
	}

@end
